
----Aggregierungsview

CREATE VIEW flaechen_einnahme as
SELECT
bewirtschafter,
count(distinct vertrag) as vertragsanzahl,
replace((group_concat(distinct vertrag)),',', ':| ' ) as teilnahme,
'{'||group_concat(distinct vertrag)||'}' as vertrags,
casttodouble(sum (Eur_ha * ha)) as Einnahme,
casttodouble(sum (ha)) as vertragsflaeche
from schlaege
where vertrag is not NULL

group by bewirtschafter


CREATE VIEW fundorteo_schlage as
select
group_concat(distinct art) as art,
count(distinct art) as artzahl,
count(fid) as anz_orte,
fl_code
from fundorte
group by fl_code



--Flächentrigger

CREATE TRIGGER flb_insert							-- trigger flb_insert erzeugen
after insert on schlaege								-- Nach jedem Einfügen auf dem Layer namen Nutzung
begin										-- Trigger starten
update schlaege 
set ha = round(((st_area(castautomagic(geometry))) / 10000),3) 	-- Berechnung der Fläche in ha unter Verwednung von castautomagic
where rowid = new.rowid;
end


CREATE TRIGGER flb_update							-- trigger flb_update erzeugen
after update of geometry							-- nach jeder Änderung der Geometriespalte Namens geometry
on schlaege									-- auf dem Layer namen Nutzung
begin										-- Trigger starten
update schlaege 
set ha = round(((st_area(castautomagic(geometry))) / 10000),3) 	-- Berechnung der Fläche in ha unter Verwednung von castautomagic
where rowid = new.rowid;							-- Nur für die geänderte Objekte
end
;


--Tabllem

create table schlaege (
nr INTEGER PRIMARY KEY Autoincrement,
fl_code varchar,
nutzung varchar,
nu_code double,
bewirtschafter varchar,
gesch_gruenlandtyp integer,
fundorte varchar,
vertrag,
mahdtermin date,
mahd integer,
duengung_fruehestens date,
arten_ergebnis integer,
ha double,
geometry
)
;

select recovergeometrycolumn('schlaege','geometry',25832,'Multipolygon');

create table fundorte (
nr INTEGER PRIMARY KEY Autoincrement,
art varchar,
anzahl integer,
status integer,
fl_code varchar,
geometry
)
;
select recovergeometrycolumn('fundorte','geometry',25832,'POINT');

create table bewirtschafter (
nr INTEGER PRIMARY KEY Autoincrement,
name,
programm,
ha_vertrag
)
;

create table vertrag (
nr INTEGER PRIMARY KEY Autoincrement,
typ varchar,
mahd integer,
duengedatum date,
arten integer
)
;
 /*
nutzungen,
pflnazenliste
grünlandtypem
spatialite -silent eingabe_workshop.sqlite < tabelle.sql
shp2sqlite.sh
*/






-- holt aus den Auftraegen den nettowertt ijn die rechnunegn
attribute(
			get_feature( 'Schlaege','fl_code', 
												attribute( $currentfeature , 'fl_code' ) 
					   ),'bewirtschafter' 
        )

attribute(
			get_feature( 'schlaege','intersects(geometry)',  --holt das feature aus den Aufträgen mit der gleicne  rechnungsnummer
												attribute( $currentfeature ,'entersectsgeometry')  -- Die rechnungsnr des aktuellen features der rechnungen
					   ),'fl_id' -- netto der auftreaege
        )
 
 
